<!-- List all the given houses using the housecard component, it will also enable pagination -->
<template>
<div>
    <div v-if="rerender">
    </div>
    <div v-else>
        <div v-if="paginatedListings.length > 0">
            <HouseCard v-for="(listing, index) in paginatedListings" :key="index" :listingId="listing.id" :agentId="listing.agentId"/>
            
            <Pagination v-if="maxPaginations > 0" v-model="pagination" :max="maxPaginations" @click="paginate"/>
        </div>
    </div>
</div> 
</template>

<script>

import HouseCard from './HouseCard'
import Pagination from './Pagination'
export default {
  name: 'HouseList',
  props: {
    listings: Array,
  },
  components: {
      HouseCard,
      Pagination
  },
  data() {
      return {
          pagination: 1,
          maxPaginations: -1,
          perPage: 10,
          paginatedListings: [],
          rerender: true
      }
  },
  mounted() {
      this.$parent.$on('update', this.filtering) //Registers a function which is executedwhenever the update event is emited from a parent.
      this.maxPaginations = Math.ceil(this.listings.length/this.perPage)
      this.paginate(1)
  },
  methods: {
      paginate(v) {

          //This part is used to actually rerender the array when we paginate.
        this.rerender = true
        setTimeout(() => {
            this.rerender = false
        }, 1);

        this.pagination = v
        let maxIndex = this.pagination*this.perPage
        if(maxIndex >= this.listings.length) {
            maxIndex = this.listings.length
        }

        this.paginatedListings = this.listings.slice((this.pagination-1)*this.perPage, maxIndex)
        
      },
      filtering() {
        this.maxPaginations = Math.ceil(this.listings.length/this.perPage)
        this.paginate(1)
      }
  }
}
</script>